unit XMLdsgn;

interface

{$I Compilers.inc}

uses SysUtils, Windows, Messages, Classes, Controls, Dialogs, XMLNode, XMLMap;

procedure Register;

implementation

uses DB,
{$ifdef DELPHI_4}
  Dsgnintf,
{$else}
  DesignEditors, DesignIntf,
{$endif}
Colnedit;

{--------------------------------------------------------------}

Type
	TXMLMapFieldEditor = Class(TStringProperty)
	public
		function GetAttributes: TPropertyAttributes; override;
		procedure GetValues(Proc: TGetStrProc); override;
	end;

function TXMLMapFieldEditor.GetAttributes: TPropertyAttributes;
begin
	Result := [paValueList, paMultiSelect];
end;

procedure TXMLMapFieldEditor.GetValues(Proc: TGetStrProc);
var
	Instance: TPersistent;
	d: TDataSet;
	i: integer;
begin
	Instance := GetComponent(0);
	if (Instance is TXMLMapField) then
		begin
			d := TXMLMapFields(TXMLMapField(Instance).Collection).Owner.DataSet;
			if d <> nil then
				for i := 0 to d.FieldCount-1 do
					Proc(d.Fields[i].FieldName);
		end;
end;

{ TXMLMapEditor }

type
	TXMLMapEditor = class(TComponentEditor)
		procedure ExecuteVerb(Index: Integer); override;
		function GetVerb(Index: Integer): string; override;
		function GetVerbCount: Integer; override;
	end;

procedure TXMLMapEditor.ExecuteVerb(Index: Integer);
var
	m: TXMLMap;
	mf: TXMLMapField;
	d: TDataSet;
	i: integer;

(*
	w: TXMLFileWriter;
	n: TXMLNode;
*)
begin
	case Index of
		0:
			begin
				// This I don't know how to handle right now
				ShowCollectionEditor(Designer, Component, TXMLMap(Component).MapFields, 'MapFields');
			end;
		1:
			if MessageDlg('Delete existing fields and insert all fields from dataset?',
				mtConfirmation, [mbOk, mbCancel], 0) = mrOk then
			begin
				// Add all fields from dataset
				m := TXMLMap(Component);
				d := m.DataSet;
				if d <> nil then
					begin
						m.MapFields.Clear;
						for i := 0 to d.FieldCount-1 do
							begin
								mf := m.MapFields.Add;
								mf.FieldName := d.Fields[i].FieldName;
								if (d.Fields[i].FieldKind = fkData) and not d.Fields[i].ReadOnly then
									mf.Direction := xdReadWrite
								else
									mf.Direction := xdWriteOnly;
								mf.WriteCDATA := d.Fields[i].DataType in [ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic, ftFmtMemo,
									ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor, ftADT, ftArray, ftReference, ftDataSet];
							end;
						Designer.Modified;
					end;
			end;
(*
		2:
			begin
				m := TXMLMap(Component);
				n := m.WriteRecords;
				w := TXMLFileWriter.Create('c:\pox.xml');
				try
					w.StartDoc;
					w.WriteNode(n);
					w.EndDoc;
				finally
					w.Free;
					n.Free;
				end;
			end;
*)
	end;
end;

function TXMLMapEditor.GetVerb(Index: Integer): string;
begin
	case Index of
		0: Result := 'Fields Editor ...';
		1: Result := 'Reset Fields';
		//2: Result := 'Write to c:\pox.xml';
	end;
end;

function TXMLMapEditor.GetVerbCount: Integer;
begin
	Result := 2;
end;

{--------------------------------------------------------------}

procedure Register;
begin
	RegisterComponents('XC', [ TXMLDoc ]);
	RegisterComponents('XD', [ TXMLMap ]);
	RegisterPropertyEditor(TypeInfo(String), TXMLMapField, 'FieldName', TXMLMapFieldEditor);
	RegisterComponentEditor(TXMLMap, TXMLMapEditor);
end;

end.

